-------- Utilities  -------------------------------
module

export Try, list_equal, zip, Cassoc, foldr1;

   type Try *a = Succeed *a + Fail
and 
   (rec
       list_equal eq [] [] = true
    || list_equal eq (_._) [] = false
    || list_equal eq [] (_._) = false
    || list_equal eq (x.xs) (y.ys) = (eq x y) & (list_equal eq xs ys)
   )
and
   zip = curry combine
and
   Cassoc l x = assoc x l
and
   (rec
       foldr1 f []  = fail "foldr1"
    || foldr1 f [x] = x
    || foldr1 f (x.xs) = f x (foldr1 f xs)
   )

end
